#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define 	homedir		%{_var}/lib/%{name}
%define 	pkgdatadir	%{_var}/lib/%{name}
%define 	pkglogdir	%{_var}/log/%{name}
%define 	daemon		clamd

#-----------------------------------------------------------------------------
Name		:	clamav
Version		:	1.4.1
Release		:	17.0.10.rel%{?dist}
Summary		:	End-user tools for the Clam Antivirus scanner

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2
URL		:	http://www.clamav.net/downloads

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	cargo
BuildRequires	:	check
BuildRequires	:	cmake
BuildRequires	:	gettext
BuildRequires	:	gcc-c++
BuildRequires	:	gettext
BuildRequires	:	json-c-devel
BuildRequires	:	libtool
BuildRequires	:	libtiff
BuildRequires	:	libmspack-devel
BuildRequires	:	linux-headers
BuildRequires	:	ncurses-devel
BuildRequires	:	ninja
BuildRequires	:	milter-devel

#-----------------------------------------------------------------------------
%description
Clam AntiVirus is an anti-virus toolkit for UNIX. The main purpose of this
software is the integration with mail servers (attachment scanning). The
package provides a flexible and scalable multi-threaded daemon, a command
line scanner, and a tool for automatic updating via Internet. The programs
are based on a shared library distributed with the Clam AntiVirus package,
which you can use with your own software. The virus database is based on
the virus database from OpenAntiVirus, but contains additional signatures
(including signatures for popular polymorphic viruses, too) and is KEPT UP
TO DATE.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%license COPYING
%doc NEWS.md README.md
%{_bindir}/clam*
%{_sbindir}/clamonacc
%{_bindir}/sigtool*
%{_mandir}/man1/clam*.1.gz
%{_mandir}/man1/sigtool.1.gz
%{_mandir}/man5/%{name}-milter.conf.5.gz
%{_mandir}/man8/%{name}-milter.8.gz
%{_mandir}/man8/clamonacc.8.gz

#=============================================================================
%package -n		%{daemon}
Summary		:	The Clam AntiVirus Daemon

#-----------------------------------------------------------------------------
Requires	:	%{name}-filesystem	=  %{version}-%{release}
Requires	:	%{name}-lib		=  %{version}-%{release}
Requires	:	coreutils
Requires	:	shadow

#-----------------------------------------------------------------------------
%description -n		%{daemon}
The Clam AntiVirus Daemon
See the README file how this can be done with a minimum of effort.
This package contains a generic system wide '%{daemon}' service

#-----------------------------------------------------------------------------
%files -n		%{daemon}
%defattr(-,%{name},%{name},-)
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{daemon}
%config(noreplace) %verify(not mtime) %{_sysconfdir}/%{name}/freshclam.conf
%config(noreplace) %verify(not mtime) %{_sysconfdir}/%{name}/%{daemon}.conf
%config(noreplace) %verify(not mtime) %{_sysconfdir}/%{name}/%{name}-milter.conf
%config(noreplace) %verify(not mtime) %attr (-,root,root) %{_sysconfdir}/logrotate.d/%{name}
%{_bindir}/freshclam
%{_sbindir}/%{daemon}
%{_sbindir}/%{name}-milter
%{_libdir}/libfreshclam.so.*
%attr(-,%{name},%{name})	%dir %{pkgdatadir}
%{_mandir}/man1/freshclam.1.gz
%{_mandir}/man5/%{daemon}.conf.5.gz
%{_mandir}/man5/freshclam.conf.5.gz
%{_mandir}/man8/%{daemon}.8.gz

#-----------------------------------------------------------------------------
#after upgrade or remove
%preun -n		%{daemon}
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{daemon} stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{daemon}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post -n		%{daemon}
%{_sbindir}/chkconfig --add %{daemon}

#=============================================================================
%package		lib
Summary		:	Dynamic libraries for the Clam Antivirus scanner

#-----------------------------------------------------------------------------
#provided by package libmspack
Requires	:	libmspack
#-----------------------------------------------------------------------------
%description		lib
This package contains dynamic libraries shared between
applications using the Clam Antivirus scanner.

#-----------------------------------------------------------------------------
%files			lib
%defattr(-,root,root,-)
%{_libdir}/lib%{name}.so.12*
%{_libdir}/libclamunrar*.so.12*

#=============================================================================
%package		filesystem
Summary		:	filesystem structure for clamav

#-----------------------------------------------------------------------------
BuildARch	:	noarch

Requires	:	logrotate
#-----------------------------------------------------------------------------
%description		filesystem
This package provides the filesystem structure and contains
the user-creation scripts required by clamav.

#-----------------------------------------------------------------------------
%files			filesystem
%defattr(-,%{name},%{name},-)
%attr(-,%{name},%{name})	%dir %{homedir}
%attr(-,%{name},%{name})	%dir %{pkglogdir}

%pre			filesystem
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{name}

  /usr/sbin/useradd 				\
	-r					\
	-c "Clam Anti Virus Checker"		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{name}				\
	-s /sbin/nologin			\
	-d %{homedir}				\
	%{name}
  fi

#after upgrade or remove
%preun			filesystem
if [ "$1" = 0 ]; then
  /usr/sbin/userdel %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#=============================================================================
%package		devel
Summary		:	Header files and libraries for the Clam Antivirus scanner

#-----------------------------------------------------------------------------
Requires	:	clamav-lib		= %{version}-%{release}
Requires	:	clamav-filesystem	= %{version}-%{release}
#-----------------------------------------------------------------------------
%description		devel
This package contains headerfiles and libraries which are needed to
build applications using '%{name}'.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}*.h
%{_includedir}/libfreshclam.h
%{_bindir}/%{name}-config
%{_libdir}/libclam*.so
%{_libdir}/libfreshclam.so
%{_libdir}/pkgconfig/lib%{name}.pc
%{_defaultdocdir}/ClamAV/html/appendix/*.html
%{_defaultdocdir}/ClamAV/html/community_resources/CommunityResources.html
%{_defaultdocdir}/ClamAV/html/community_resources/CompileClamAV_AmazonLinux2.txt
%{_defaultdocdir}/ClamAV/html/css/*.css
%{_defaultdocdir}/ClamAV/html/faq/*.html
%{_defaultdocdir}/ClamAV/html/*.png
%{_defaultdocdir}/ClamAV/html/*.html
%{_defaultdocdir}/ClamAV/html/*.js
%{_defaultdocdir}/ClamAV/html/*.json
%{_defaultdocdir}/ClamAV/html/*.css
%{_defaultdocdir}/ClamAV/html/FontAwesome/css/*.css
%{_defaultdocdir}/ClamAV/html/FontAwesome/fonts/*.ttf
%{_defaultdocdir}/ClamAV/html/FontAwesome/fonts/*.eot
%{_defaultdocdir}/ClamAV/html/FontAwesome/fonts/*.svg
%{_defaultdocdir}/ClamAV/html/FontAwesome/fonts/*.woff
%{_defaultdocdir}/ClamAV/html/FontAwesome/fonts/*.woff2
%{_defaultdocdir}/ClamAV/html/fonts/fonts.css
%{_defaultdocdir}/ClamAV/html/fonts/*.txt
%{_defaultdocdir}/ClamAV/html/fonts/*.woff2
%{_defaultdocdir}/ClamAV/html/images/flamegraph.svg
%{_defaultdocdir}/ClamAV/html/images/*.png
%{_defaultdocdir}/ClamAV/html/manual/*.html
%{_defaultdocdir}/ClamAV/html/manual/Development/*.html
%{_defaultdocdir}/ClamAV/html/manual/Installing/*.html
%{_defaultdocdir}/ClamAV/html/manual/Signatures/*.html
%{_defaultdocdir}/ClamAV/html/manual/Usage/*.html
%{_defaultdocdir}/ClamAV/html/manual/cisco-talos.gpg
%{_defaultdocdir}/ClamAV/html/sitemap.xml

#=============================================================================
%prep
%setup -q
tar xf %{SOURCE1}

#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	-D CMAKE_BUILD_TYPE=Release			\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D CMAKE_INSTALL_LIBDIR=%{_libdir}		\
	-D CMAKE_INSTALL_SBINDIR=%{_sbindir}		\
	-D APP_CONFIG_DIRECTORY=%{_sysconfdir}/%{name}	\
	-D DATABASE_DIRECTORY=%{pkgdatadir}		\
	-D ENABLE_EXTERNAL_MSPACK=ON			\
	-W no-dev					\
	-B build					\
	-G Ninja					\
	-S .

ninja							\
	-C build

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	ninja 						\
		-C build				\
		install


#To remove libtool library and static library
find 							\
	%{buildroot}%{_libdir}				\
	\(						\
		 -name \*.la				\
		 -o					\
		 -name \*.a				\
	 \)						\
	-delete

%{__mkdir_p}						\
	%{buildroot}%{pkglogdir}			\
	%{buildroot}%{pkgdatadir}			\
	%{buildroot}%{homedir}

#working out configuration files
pushd %{buildroot}%{_sysconfdir}/%{name}
%{__mv}							\
	freshclam.conf.sample				\
	freshclam.conf

%{__mv}							\
	%{daemon}.conf.sample				\
	%{daemon}.conf

%{__mv}							\
	%{name}-milter.conf.sample			\
	%{name}-milter.conf
#configuration for osukiss
sed -i							\
        -e "s/^Example/#Example/"			\
        -e "s/^#TCPSocket/TCPSocket/"			\
	%{daemon}.conf

cat >> %{daemon}.conf << "EOF"
#-------------------------------------------------------
#Osukiss adjustment
LogTime yes
PidFile /run/clamd.pid
LocalSocket /run/clamd.socket
LogFile /var/log/clamav/clamd.log
#-------------------------------------------------------
EOF

sed -i							\
        -e "s/^Example/#Example/"			\
	freshclam.conf

cat >> freshclam.conf << "EOF"
#-------------------------------------------------------
#Osukiss adjustment
LogTime yes
PidFile /run/freshclam.pid
UpdateLogFile /var/log/clamav/freshclam.log
#-------------------------------------------------------
EOF
popd

#installing %{daemon} starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 						\
	%{name}-ok_addon/%{daemon}			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#installing clamav log rotate directive
%{__mkdir_p} %{buildroot}%{_sysconfdir}/logrotate.d
%{__cp} -a 						\
	%{name}-ok_addon/%{name}			\
	%{buildroot}%{_sysconfdir}/logrotate.d


#-----------------------------------------------------------------------------
%changelog
